#include <Wire.h>
#include "Adafruit_VL53L0X.h"

Adafruit_VL53L0X lox = Adafruit_VL53L0X();

const int DRV8830 = 0x60;
byte direct;
void writeRegister(byte reg, byte vset, byte data){
  int vdata = vset <<2 | data;
  Wire.beginTransmission(DRV8830);
  Wire.write(reg);
  Wire.write(vdata);
  Wire.endTransmission(true);
}

void setup() {
  Wire.begin();
  writeRegister(0x00,0x00,0x00);
  lox.begin();
  for(int i=11;i<14;i++){
  pinMode(i, OUTPUT);
  }
  direct=2;//initial rotation to forward
}

void loop() {
  if((measureheight()<60)&&(measureheight()!=4000)){
    motordrive(6, 3);//stop
    if(direct==1){
      direct=2;
    }else{
      direct=1;
    }
    //direct=~direct&0b11;
    leddrive(direct);
    delay(2000);
  }
  leddrive(direct);
  motordrive(measureheight(),direct);
  leddrive(direct);
}

void motordrive(int height2, byte param3){
  byte param2;
//expected maximum height=600,min=100 mm
//param 3 = 0:stand-by, 1:backward, 2:forward, 3:break
//param 2 = minimum 10, maximum 63
  param2=(height2/100)*12+30;
  if((param2>62)||(param2==4000)){
    param2=6;
    param3=3;
    leddrive(3);
  }
  writeRegister(0x00,param2,param3);
  delay(10);
}

int measureheight(void){
    int mlength;
  VL53L0X_RangingMeasurementData_t measure;
  lox.rangingTest(&measure, false);
  if (measure.RangeStatus != 4) {
    mlength=measure.RangeMilliMeter;
  }else{
    mlength=4000;
  }
  return mlength;
}

void leddrive(byte stat){
  switch(stat){
    case 0://stand-by
      digitalWrite(11, LOW);//blue
      digitalWrite(12, HIGH);//green
      digitalWrite(13, HIGH);//red
    break;
    case 1://reverse
      digitalWrite(11, HIGH);//blue
      digitalWrite(12, HIGH);//green
      digitalWrite(13, LOW);//red
    break;
    case 2://forward
      digitalWrite(11, HIGH);//blue
      digitalWrite(12, LOW);//green
      digitalWrite(13, HIGH);//red
    break;
    case 3://stop
      digitalWrite(11, LOW);//blue
      digitalWrite(12, HIGH);//green
      digitalWrite(13, HIGH);//red
    break; 
    default:
    break;       
  }
}

